var $ = jQuery;
$(function() {
var jSubmodulePrototype = $($.parseHTML(
								'<div class="submodule">\
									<div class="name">\
										<input type="text" class="inputName submoduleName" value="" placeholder="Наименование мероприятия">\
									</div>\
									<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value="0"></div>\
									<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value="0"></div>\
									<div class="actions">\
										<div class="deleteSubmodule icon delete"></div>\
										<div class="downSubmodule icon down"></div>\
										<div class="upSubmodule icon up"></div>\
									</div>\
								</div>'
							));

var	jModulePrototype 	= $($.parseHTML(
								'<div class="moduleGroup">\
									<div class="moduleHead">\
										<div class="name">\
											<input type="text" class="inputName moduleName" value="" placeholder="Наименование модуля">\
										</div>\
										<div class="currentControl">0</div>\
										<div class="landmarkControl">0</div>\
										<div class="actions">\
											<div class="deleteModule icon delete"></div>\
											<div class="downModule icon down"></div>\
											<div class="upModule icon up"></div>\
										</div>\
									</div>\
									<div class="submodules"></div>\
									<button class="addSubmodule">Добавить мероприятие</button>\
								</div>'
							)); 

var jConfirmPrototype 	= $($.parseHTML(
								'<div class="confirmDeleteDiv">Уверены? <span class="confirmDeleteModule">Да</span> <span class="cancel">Нет</span></div>'
							));

	// Шаблон мероприятия
	function ConstructSubmodule(){
		return jSubmodulePrototype.clone();
	}

	// Шаблон модуля
	function ConstructModule() {
		var ret = jModulePrototype.clone();
		ret.children('div.submodules').append(ConstructSubmodule());
		return ret;
	};

	// Подсчет текущего контроля
	function CountCurrentControl(jSubModulesDiv){
		var maxCredits = 0;
		$('input.inputCurrentControl', jSubModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0);
		});
		jSubModulesDiv.prev().children('div.currentControl').text(maxCredits);
	}
	// Подсчет рубежного контроля
	function CountLandmarkControl(jSubModulesDiv){
		var maxCredits = 0;
		$('input.inputLandmarkControl', jSubModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		jSubModulesDiv.prev().children('div.landmarkControl').text(maxCredits);
	}
	

	function ChangeSubModuleMaxAndControl(jThis, ID, newMaxRate, controlType) { 
		$.post(
			g_URLdir + 'handler/map/ChangeSubModuleMaxAndControl',
			{
				'SubmoduleID': ID,
				'MaxRate': newMaxRate,
				'ControlType': controlType
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true)
					EventInspector_ShowMsg('Max балл мероприятия изменен', 'success');
				else EventInspector_ShowMsg('Ошибка при изменении max балла', 'error');
				jThis.removeAttr('disabled');
			}
		);
	}
	
	// Установить новый max балл
	function SetNewRateAndControl(jThis, oldMaxRate) {
		// DIV с мероприятиями для данного модуля
		var jSubModulesDiv = jThis.parent().parent().parent();
		// ID мероприятия
		var ID = jThis.parent().parent().attr('id');
		var newMaxRate = 0;
		if (jThis.val().length > 0 )
			newMaxRate = parseInt(jThis.val());
		
		// Ограничение 100 баллов
		var maxSumRate = 100;
		if ($('div.ExamModule').first().length > 0) maxSumRate = 60;
		
		var currentControl = 0;
		$('div.moduleHead').children('div.currentControl').each(function(){
			currentControl += parseInt($(this).text());
		});
		
		var landmarkControl = 0;
		$('div.moduleHead').children('div.landmarkControl').each(function(){
			landmarkControl += parseInt($(this).text());
		});
		
		var subtract = 0;
		if (jThis.parent().attr('class').indexOf('landmarkControl') + 1 > 0)
			subtract = parseInt(jThis.parent().siblings('.currentControl').children().val());
		if (jThis.parent().attr('class').indexOf('currentControl') + 1 > 0)
			subtract = parseInt(jThis.parent().siblings('.landmarkControl').children().val());
			
		if (currentControl + landmarkControl + newMaxRate - subtract - oldMaxRate > maxSumRate) {
			if (newMaxRate == 0)
				jThis.val('0');
			else {
				EventInspector_ShowMsg('Сумма баллов превышает максимум', 'error');
				jThis.val(oldMaxRate);
				jThis.removeAttr('disabled')
				return 0;
			}
		}
		
		// Меняем max балл
		if (newMaxRate != oldMaxRate) {

			controlType = 'CurrentControl'; // По-умолчанию 
			if ((jThis.parent().attr('class')).indexOf('landmarkControl') + 1 > 0)
				controlType = 'LandmarkControl';


			ChangeSubModuleMaxAndControl(jThis, ID, newMaxRate, controlType);
			
			// Счетчик баллов
			var rateIndicarot = currentControl + landmarkControl + newMaxRate - subtract - oldMaxRate;
			if ($('div.ExamModule').length > 0) rateIndicarot += 40;
			$('div.rateIndicatorDIV span.rateIndicator').html(rateIndicarot);
			
			if (controlType == 'CurrentControl')
				jThis.parent().parent().find('div.landmarkControl').children('input.inputLandmarkControl').val('0');
				
			if (controlType == 'LandmarkControl')
				jThis.parent().parent().find('div.currentControl').children('input.inputCurrentControl').val('0');
		} else jThis.removeAttr('disabled');
		
		// Подсчет текущего и рубежного контроля после изменений
		CountCurrentControl(jSubModulesDiv);
		CountLandmarkControl(jSubModulesDiv);
	}
	
	// Поменять местами два модуля
	function SwapModuleOrder(jModule1, jModule2) {
		$.post(
			g_URLdir + 'handler/map/SwapModuleOrder',
			{
				'ModuleID1': jModule1.attr('id'),
				'ModuleID2': jModule2.attr('id')
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					EventInspector_ShowMsg('Модули поменяли порядок', 'success');
					jModule1.insertBefore(jModule2);
				}
				else EventInspector_ShowMsg('Ошибка при изменении порядка модулей', 'error');
			}
		);
	}
	
	// Поменять местами два мероприятия
	function SwapSubmoduleOrder(jSubmodule1, jSubmodule2) {
		$.post(
			g_URLdir + 'handler/map/SwapSubmoduleOrder',
			{
				'SubmoduleID1': jSubmodule1.attr('id'),
				'SubmoduleID2': jSubmodule2.attr('id')
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					EventInspector_ShowMsg('Мероприятия поменяли порядок', 'success');
					jSubmodule1.insertBefore(jSubmodule2);
				}
				else 
					EventInspector_ShowMsg('Ошибка при изменении порядка мероприятий', 'error');
			}
		);
	}
	
//-------------------------------------------------------------------------------------------------------------------------------------------------
	
	// Переместить вверх МОДУЛЬ
    $(".moduleList").on('click', '.upModule', function(){
        var jCkickedModule = $(this).parent().parent().parent();
		var jModuleGroupDiv = jCkickedModule.prev('div.moduleGroup');
		if (jModuleGroupDiv.length > 0) {
			SwapModuleOrder(jCkickedModule, jModuleGroupDiv);
		}
    });
	
	// Переместить вниз МОДУЛЬ
    $(".moduleList").on('click', '.downModule', function(){
        var jCkickedModule = $(this).parent().parent().parent();
		var jModuleGroupDiv = jCkickedModule.next('div.moduleGroup');
		if (jModuleGroupDiv.length > 0) {
			SwapModuleOrder(jModuleGroupDiv, jCkickedModule);
		}
    });
	
	// Переместить вверх мероприятие
    $(".moduleList").on('click', '.upSubmodule', function(){
        var jCkickedSubmodule = $(this).parent().parent();
		var jSubModule = jCkickedSubmodule.prev('div.submodule');
		if (jSubModule.length > 0) {
			SwapSubmoduleOrder(jCkickedSubmodule, jSubModule);
		}
    });
	
	// Переместить вниз мероприятие
    $(".moduleList").on('click', '.downSubmodule', function(){
        var jCkickedSubmodule = $(this).parent().parent();
		var jSubModule = jCkickedSubmodule.next('div.submodule');
		if (jSubModule.length > 0) {
			SwapSubmoduleOrder(jSubModule, jCkickedSubmodule);
		}
    });
	
	// Добавить модуль
	$('.addModule').click(function(){
		var jThis = $(this);
    	$(this).attr("disabled", true);
		var orderNum = $('div.moduleGroup', 'div.moduleList').last().index('.moduleGroup') + 2;
		$.post(
			g_URLdir + 'handler/map/AddModule',
			{
				'DisciplineID': g_disciplineID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					var place = $('.moduleList').children('.moduleGroup').last();
					if (place.length > 0) 
						place.after(ConstructModule());
					else {
						$('div.moduleList').prepend(ConstructModule());
					}
						
					// К добавленному модулю добавляем ID
					var thisModuleDIV = $('div.moduleGroup').eq(orderNum - 1);
					thisModuleDIV.attr('id', data.moduleID);
					// К добавленному в модуль мероприятию добавляем ID
					thisModuleDIV.children('div.submodules').children('div.submodule').eq(0).attr('id', data.submoduleID);
					EventInspector_ShowMsg('Модуль добавлен', 'success');
				} else 
					EventInspector_ShowMsg('Ошибка при добавлении модуля', 'error');
				jThis.removeAttr('disabled');
			}
		);
		
		$('.empty').remove();
		
	});
	
	// Добавить мероприятие
	$('div.moduleList').on('click', 'button.addSubmodule', function(){
		var jThis = $(this);
    	$(this).attr("disabled", true);
		var submoduleID = $(this).parent().attr('id');
		var jSubmodulesDIV = $(this).siblings('div.submodules');
		var orderNum = jSubmodulesDIV.children('div.submodule').last().index() + 2;
		$.post(
			g_URLdir + 'handler/map/AddSubmodule',
			{
				'submoduleID': submoduleID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					// К добавленному мероприятию добавляем ID
					jSubmodulesDIV.append(ConstructSubmodule());
					jSubmodulesDIV.children('div.submodule').eq(orderNum - 1).attr('id', data.submoduleID);
					EventInspector_ShowMsg('Мероприятие добавлено', 'success');
				} else EventInspector_ShowMsg('Ошибка при добавлении мероприятия', 'error');
				jThis.removeAttr('disabled');
			}
		);
	});


	
	// Удалить модуль
	$('.moduleList').on('click', '.deleteModule', function(){
		$(this).parent().css('display', 'none');
		$(this).parent().parent().append(jConfirmPrototype.clone());

	});
	
	// Подтверждение при удаление модуля
	$('.moduleList').on('click', '.confirmDeleteModule', function(){
		var jThis = $(this);

		$.post(
			g_URLdir + 'handler/map/DeleteModule',
			{
				'ModuleID': $(this).parent().parent().parent().attr('id'),
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					jThis.parent().parent().parent().remove();
					
					var c = 0;
					$('div.moduleGroup')
						.children('div.moduleHead')
						.children('div.currentControl')
						.each(function(){
							c += parseInt($(this).text());
						});
						
					var l = 0;
					$('div.moduleGroup')
						.children('div.moduleHead')
						.children('div.landmarkControl')
						.each(function(){
							l += parseInt($(this).text());
						});
					
					var e = 0;
					if ($('div.ExamModule').length > 0) e = 40;
					
					$('span.rateIndicator').html(c + l + e);

					if ($('div.moduleGroup').length == 0)
						$('.moduleList').prepend('<div class="empty"><p class="notification">Модули отсутствуют</p></div>'); // Показываем 'Модули отсутствуют'
						
					EventInspector_ShowMsg('Модуль удален', 'success');
				}
				else EventInspector_ShowMsg('Ошибка при удаление модуля', 'error');
			}
		);

	});
	
	// Удалить мероприятие
	$('.moduleList').on('click', '.deleteSubmodule ', function(){
		if ($(this).parent().parent().parent().children().size() <= 1) {
			EventInspector_ShowMsg('Невозможно удалить единственное мероприятие в модуле.', 'error');
			return;
		}
		$(this).parent().css('display', 'none');
		$(this).parent().parent().append('<div class="confirmDeleteDiv">Уверены? <span class="confirmDeleteSubmodule">Да</span> <span class="cancel">Нет</span></div>');
	});
	
	// Подтверждение при удаление мероприятия
	$('.moduleList').on('click', '.confirmDeleteSubmodule ', function(){
		var jThis = $(this);
		var jSubmodulesDiv = $(this).parent().parent().parent();
		if (jSubmodulesDiv.children().size() <= 1) {
			EventInspector_ShowMsg('Невозможно удалить единственное мероприятие в модуле.', 'error');
			return;
		}
		CountCurrentControl(jSubmodulesDiv);
		CountLandmarkControl(jSubmodulesDiv);

		$.post(
			g_URLdir + 'handler/map/DeleteSubmodule',
			{
				'SubmoduleID': $(this).parent().parent().attr('id')
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					var sub = jThis.parent().parent();
					var mod = sub.parent().parent().find('div.moduleHead');
					// get old jSubModule values
					var dif1 = parseInt(sub.find('div.currentControl').find('input').val());
					var dif2 = parseInt(sub.find('div.landmarkControl').find('input').val());
					
					// change module header
					var old = parseInt(mod.find('div.currentControl').html());
					mod.children('div.currentControl').html(old - dif1);

					old = parseInt(mod.find('div.landmarkControl').html());
					mod.children('div.landmarkControl').html(old - dif2);

					// change sum rate
					var rateIndicator = $('span.rateIndicator');
					old = rateIndicator.html();
					rateIndicator.html(old - dif1 - dif2);
					
					jThis.parent().parent().remove();
					EventInspector_ShowMsg('Мероприятие удалено', 'success');
				}
				else EventInspector_ShowMsg('Ошибка при удалении мероприятия', 'error');
			}
		);
	});
	
	// Отмена удаления модулей/мероприятий
	$('.moduleList').on('click', '.cancel ', function(){
		$(this).parent().parent().children('div.actions').css('display', 'block');
		$(this).parent().remove();
	});
	
	// Поменять название модуля
	var moduleName;
	$('div.moduleList').on('focusin', 'input.moduleName', function(){
		moduleName = $(this).val();
	});
	$('div.moduleList').on('focusout', 'input.moduleName', function(){
		var jThis = $(this);
    	$(this).attr("disabled", true);
		var newModuleName = $(this).val();
		if (newModuleName !== '' && moduleName !== newModuleName) {
			var ID = $(this).parent().parent().parent().attr('id');
			$.post(
				g_URLdir + 'handler/map/ChangeModuleName',
				{
					'ModuleID': ID,
					'ModuleName': newModuleName
				},
				function(data){
					data = $.parseJSON(data);
					if(data.success === true)
						EventInspector_ShowMsg('Имя модуля изменено', 'success');
					else EventInspector_ShowMsg('Ошибка при изменении имени модуля', 'error');
					jThis.removeAttr('disabled');
				}
			);
		} else jThis.removeAttr('disabled');
	});
	$('.moduleList').on('keydown', '.moduleName', function(e){
		if(e.keyCode==13){
			$('.moduleName').trigger('focusout');
		}
	});
	
	// Поменять название мероприятие
	var submoduleName;
	$('div.moduleList').on('focusin', 'input.submoduleName', function(){
		submoduleName = $(this).val();
	});
	$('div.moduleList').on('focusout', 'input.submoduleName', function(){
		var jThis = $(this);
    	$(this).attr("disabled", true);
		var newSubmoduleName = $(this).val();
		if (newSubmoduleName !== '' && submoduleName !== newSubmoduleName) {
			var ID = $(this).parent('div').parent('div').attr('id');
			$.post(
				g_URLdir + 'handler/map/ChangeSubmoduleName',
				{
					'SubmoduleID': ID,
					'SubmoduleName': newSubmoduleName
				},
				function(data){
					data = $.parseJSON(data);
					if(data.success === true)
						EventInspector_ShowMsg('Имя мероприятия изменено', 'success');
					else EventInspector_ShowMsg('Ошибка при изменении имени мероприятия', 'error');
					jThis.removeAttr('disabled');
				}
			);
		} else jThis.removeAttr('disabled');
	});
	$('div.moduleList').on('keydown', 'input.jSubModuleName', function(e){
		if(e.keyCode==13){
			$('.jSubModuleName').trigger('focusout');
		}
	});
	
	// При записи в input текущий контроль
	// При фокусе
	var oldMaxRate = 0;
	$('div.moduleList').on('focusin', 'input.inputCurrentControl', function(){
		oldMaxRate = $(this).val();
	});
	// При потери фокуса
	$('div.moduleList').on('focusout', 'input.inputCurrentControl', function(){
    	$(this).attr("disabled", true);
		SetNewRateAndControl($(this), oldMaxRate);
	});
	
	// При записи в input рубежный контроль
	// При фокусе
	var oldMaxRate = 0;
	$('div.moduleList').on('focusin', 'input.inputLandmarkControl', function(){
		oldMaxRate = $(this).val();
	});
	// При потере фокуса
	$('div.moduleList').on('focusout', 'input.inputLandmarkControl', function(){
		$(this).attr("disabled", true);
		SetNewRateAndControl($(this), oldMaxRate);
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$("div.moduleList").on('keydown', 'input.inputCredit', function(event) {
        KeyDownOnlyNumber(event);
    });


});
